SystemOrganization addCategory: #'Keymapping-Pragmas'!

Object subclass: #KMBuilder
	instanceVariableNames: 'platform'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Pragmas'!

!KMBuilder class methodsFor: 'instance creation' stamp: 'GuillermoPolito 10/21/2011 00:08'!
keymap
	^self keymap: #all! !

!KMBuilder class methodsFor: 'instance creation' stamp: 'GuillermoPolito 10/21/2011 01:15'!
keymap: aPlatform
	(#( all Unix MacOSX Windows ) includes: aPlatform) ifFalse: [ self error: aPlatform, ' is not a valid platform' ].
	^self new
		platform: aPlatform;
		yourself! !

!KMBuilder methodsFor: 'keymap-building' stamp: 'GuillermoPolito 5/31/2011 13:45'!
attachShortcutCategory: aByteSymbol to: aClass
	KMRepository default attachCategoryName: aByteSymbol to: aClass.! !

!KMBuilder methodsFor: 'accessing' stamp: 'GuillermoPolito 10/21/2011 00:12'!
platform: aPlatform
	platform := aPlatform! !

!KMBuilder methodsFor: 'keymap-building' stamp: 'GuillermoPolito 10/21/2011 01:26'!
shortcut: aKeymapName
	^KMKeymapBuilder 
		for: aKeymapName
		platform: platform! !

Object subclass: #KMKeymapBuilder
	instanceVariableNames: 'shortcutName platform'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Pragmas'!

!KMKeymapBuilder class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/21/2011 00:14'!
for: aShortcutName platform: aPlatform
	^self new 
		shortcutName: aShortcutName;
		platform: aPlatform;
		yourself! !

!KMKeymapBuilder methodsFor: 'building' stamp: 'GuillermoPolito 10/21/2011 00:21'!
category: aCategoryName default: aShortcut do: anAction
	KMRepository default
		initializeKeymap: shortcutName
		executingOn: aShortcut
		doing: anAction
		inCategory: aCategoryName
		platform: platform! !

!KMKeymapBuilder methodsFor: 'building' stamp: 'GuillermoPolito 4/6/2012 13:23'!
category: aCategoryName default: aShortcut do: anAction description: aDescription
	KMRepository default
		initializeKeymap: shortcutName
		executingOn: aShortcut
		doing: anAction
		inCategory: aCategoryName
		platform: platform
		description: aDescription! !

!KMKeymapBuilder methodsFor: 'accessing' stamp: 'GuillermoPolito 10/21/2011 01:26'!
platform: aPlatform
	platform := aPlatform! !

!KMKeymapBuilder methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 11:57'!
shortcutName: aShortcutName
	shortcutName := aShortcutName! !

Object subclass: #KMPragmaKeymapBuilder
	instanceVariableNames: 'pragmaKeywords model pragmaCollector'
	classVariableNames: 'UniqueInstace'
	poolDictionaries: ''
	category: 'Keymapping-Pragmas'!

!KMPragmaKeymapBuilder class methodsFor: 'private' stamp: 'GuillermoPolito 4/30/2012 18:56'!
event: anEvent
	anEvent item ifNil: [ ^self ].
	((anEvent item pragmas collect: #keyword) includesAnyOf: self pragmas )
		ifTrue: [ self uniqueInstance reset ]! !

!KMPragmaKeymapBuilder class methodsFor: 'instance creation' stamp: 'GuillermoPolito 6/4/2012 16:31'!
initialize
	"KMPragmaKeymapBuilder initialize"
	SystemAnnouncer unsubscribe: self.
	SystemAnnouncer current on: MethodAdded, MethodModified, MethodRemoved send: #event: to: self.
	
	self uniqueInstance reset.! !

!KMPragmaKeymapBuilder class methodsFor: 'instance creation' stamp: 'GuillermoPolito 10/20/2011 23:55'!
pragmas
	^#(#keymap #keymap:)! !

!KMPragmaKeymapBuilder class methodsFor: 'instance creation' stamp: 'GuillermoPolito 5/4/2012 22:23'!
release
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self.
	self uniqueInstance release! !

!KMPragmaKeymapBuilder class methodsFor: 'instance creation' stamp: 'GuillermoPolito 10/20/2011 23:59'!
uniqueInstance
	^UniqueInstace ifNil: [ UniqueInstace := self new ]! !

!KMPragmaKeymapBuilder methodsFor: 'accessing' stamp: 'GuillermoPolito 12/17/2010 00:46'!
builder
	^ self! !

!KMPragmaKeymapBuilder methodsFor: 'registrations handling' stamp: 'GuillermoPolito 10/21/2011 00:13'!
collectRegistrations
	self pragmaCollector
		do: [:prg | prg methodClass theNonMetaClass 
				perform: prg selector
				with: (KMBuilder perform: prg keyword withArguments: prg arguments )].
! !

!KMPragmaKeymapBuilder methodsFor: 'initialize-release' stamp: 'GuillermoPolito 12/17/2010 00:58'!
initialize
	super initialize.
	pragmaKeywords := OrderedCollection new.
	! !

!KMPragmaKeymapBuilder methodsFor: 'accessing' stamp: 'GuillermoPolito 12/17/2010 00:46'!
itemReceiver
	^ model! !

!KMPragmaKeymapBuilder methodsFor: 'accessing' stamp: 'GuillermoPolito 12/17/2010 00:46'!
model
	^ model! !

!KMPragmaKeymapBuilder methodsFor: 'accessing' stamp: 'GuillermoPolito 12/17/2010 00:46'!
model: anObject
	model := anObject! !

!KMPragmaKeymapBuilder methodsFor: 'registrations handling' stamp: 'GuillermoPolito 10/21/2011 00:00'!
pragmaCollector
	"Return an up-to-date pragmaCollector which contains all pragmas which keyword is self pragmaKeyword"
	^ pragmaCollector 
		ifNil: [pragmaCollector:= (PragmaCollector filter: [:prg | (self pragmaKeywords includes: prg keyword) and: [prg selector numArgs = 1]]).
			(self pragmaKeywords notNil and: [self pragmaKeywords notEmpty])  ifTrue: [pragmaCollector reset].
			pragmaCollector whenChangedSend: #reset to: self.
			pragmaCollector]! !

!KMPragmaKeymapBuilder methodsFor: 'accessing' stamp: 'GuillermoPolito 10/21/2011 00:04'!
pragmaKeywords
	"Returns the pragmas keyword used to select pragmas (see #pragmaCollector)"
	^  self class pragmas! !

!KMPragmaKeymapBuilder methodsFor: 'initialize-release' stamp: 'GuillermoPolito 5/4/2012 23:00'!
release
	self pragmaCollector unsubscribe: self.
	self pragmaCollector announcer initialize. "Hack because the announcer is not garbage collected."
	pragmaCollector := nil.
	model := nil.
	super release
	! !

!KMPragmaKeymapBuilder methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/27/2011 18:10'!
reset
	pragmaCollector := nil.
	"KeymapManager default: KeymapManager new."
	self collectRegistrations.! !
KMPragmaKeymapBuilder initialize!
